﻿using System;

namespace CryptoCalc
{
    public class DB_Classes
    {
        public class Transaction
        {
            #region Constructors
            public Transaction() { }

            public Transaction(string _currency, float _amount, string _type, string _feeCurrency, float _feeAmount)
            {
                Year = DateTime.Now.Year;
                Month = DateTime.Now.Month;
                Day = DateTime.Now.Day;
                Hour = DateTime.Now.Hour;
                Minute = DateTime.Now.Minute;
                Second = DateTime.Now.Second;
                DateTimeString = DateTime.Now.ToString();
                Currency = _currency;
                Amount = _amount;
                TransactionType = _type;
                FeeCurrency = _feeCurrency;
                FeeAmount = _feeAmount;
                Service = "";
                Comment = "";
            }

            #endregion

            #region Publics

            public int Index { get; set; }
            public int Year { get; set; }
            public int Month { get; set; }
            public int Day { get; set; }
            public int Hour { get; set; }
            public int Minute { get; set; }
            public int Second { get; set; }
            public string DateTimeString { get; set; }
            public string Currency { get; set; }
            public float Amount { get; set; }
            public string TransactionType { get; set; }
            public string FeeCurrency { get; set; }
            public float FeeAmount { get; set; }
            public string Service { get; set; }
            public string Comment { get; set; }

            #endregion
            #region Functions
            public string FullInfo => $"{ Index.ToString() } { DateTimeString } { Currency } { Amount } { TransactionType }";

            #endregion
        }
        public class RawData
        {
            #region Contructors
            public RawData() { }
            public RawData(string _currency, float _amount, string _type)
            {
                Date_Year = DateTime.Now.Year;
                Date_Month = DateTime.Now.Month;
                Date_Day = DateTime.Now.Day;
                Time_Hour = DateTime.Now.Hour;
                Time_Minute = DateTime.Now.Minute;
                Time_Second = DateTime.Now.Second;
                DateTimeString = DateTime.Now.ToString();
                CryptoCurrency = _currency;
                Amount = _amount;
                TransactionType = _type;
                Service = "";
                Comment = "";
            }

            #endregion

            #region Publics

            public int Index { get; set; }
            public int Date_Year { get; set; }
            public int Date_Month { get; set; }
            public int Date_Day { get; set; }
            public int Time_Hour { get; set; }
            public int Time_Minute { get; set; }
            public int Time_Second { get; set; }
            public string DateTimeString { get; set; }
            public string CryptoCurrency { get; set; }
            public float Amount { get; set; }
            public string TransactionType { get; set; }
            public string Service { get; set; }
            public string Comment { get; set; }

            #endregion

            #region Functions
            public string FullInfo => $"{ Index.ToString() } { DateTimeString } { CryptoCurrency } { Amount } { TransactionType }";

            #endregion

        }

        public class Wallet
        {
            #region Constructors
            public Wallet()
            {
                //wCreationYear = 0;
                //wCreationMonth = 0;
                //wCreationDay = 0;
                //wLastActivityYear = 0;
                //wLastActivityMonth = 0;
                //wLastActivityDay = 0;
                //wLastActivityHour = 0;
                //wLastActivityMinute = 0;
                //wLastActivitySecond = 0;
                //wPlatform = "";
                //wName = "";
                //wCurrency = "";
                //wBalance = 0f;
                //wDefaultWallet = "";
                //wNotes = "";
            }

            public Wallet(int _year, int _month, int _day, string _platform, string _name, string _currency, float _balance, int _default, string _note)
            {
                wCreationYear = _year;
                wCreationMonth = _month;
                wCreationDay = _day;
                wPlatform = _platform;
                wName = _name;
                wCurrency = _currency;
                wBalance = _balance;
                wDefaultWallet = _default;
                wNotes = _note;
            }

            #endregion

            #region Publics

            public int Index { get; set; }
            public int wCreationYear { get; set; }
            public int wCreationMonth { get; set; }
            public int wCreationDay { get; set; }
            public int wLastActivityYear { get; set; }
            public int wLastActivityMonth { get; set; }
            public int wLastActivityDay { get; set; }
            public int wLastActivityHour { get; set; }
            public int wLastActivityMinute { get; set; }
            public int wLastActivitySecond { get; set; }
            public string wPlatform { get; set; }
            public string wName { get; set; }
            public string wCurrency { get; set; }
            public float wBalance { get; set; }
            public int wDefaultWallet { get; set; }
            public string wNotes { get; set; }

            #endregion
            #region Functions
            //public string FullInfo => $"{ Index.ToString() } { DateTimeString } { Currency } { Amount } { TransactionType }";

            #endregion
        }
    }
}
